/*
 * File : dlInSetupPending.h
 *
 * Description : This file contains the class declaration for 
 *	dlInSetupPending.
 */

#ifndef _dlInSetupPending_h_
#define _dlInSetupPending_h_


#include "dlStateMachine.h"
/*
 * Class : dlInSetupPending
 *
 * Description : This class inherits from dlStateMachine and provides
 *	behaviour for the dlInSetupPending state of the data-link layer.
 *	It redefines methods to handle DL_ConnectRes, DL_DisconnectRes,
 *	DL_ResetRes and DISC command.
 * Attribute:
 *	_lastPBit : P bit value of the SABM frame which caused a
 *	transition to this dlInSetupPending state.
 */


class dlInSetupPending : public dlStateMachine {

 public:
	dlInSetupPending(dllayer *dl);
	virtual ~dlInSetupPending() {}
	virtual void PrintState(); 
	virtual dlStateMachine *DlConnectRes(int &errorCode); 
	virtual dlStateMachine *DlDisconnectReq(int &errorCode); 
	virtual dlStateMachine *DlResetRes(int &errorCode); 
	virtual dlStateMachine *HandleDisc(int &errorCode); 

 private:
	int _lastPBit;
};


#endif
