/*
 * File : dlOutSetupPending.h
 *
 * Description : This file contains the class declaration for 
 * the dlOutSetupPending class.
 */

#ifndef _dlOutSetupPending_h_
#define _dlOutSetupPending_h_


#include "dlStateMachine.h"

/*
 * Class : dlOutSetupPending
 *
 * Description : This class inherits from dlStateMachine, and
 * provides the functionality to implement the dlOutSetupPending
 * state of the data-link layer. Redefines functions to handle
 * DL_DisconnectReq, T1 timer, UA, DM, DISC and SABM.
 */

class dlOutSetupPending : public dlStateMachine {

public:
	dlOutSetupPending(dllayer *dl) : dlStateMachine(dl) {}
	virtual ~dlOutSetupPending() {}
	virtual void PrintState(); 

	virtual dlStateMachine *DlDisconnectReq(int &errorCode);
	virtual dlStateMachine *HandleT1Timer(int &errorCode);
	virtual dlStateMachine *HandleUa(int &errorCode); 
	virtual dlStateMachine *HandleDm(int &errorCode); 
	virtual dlStateMachine *HandleDisc(int &errorCode); 
	virtual dlStateMachine *HandleSabm(int &errorCode); 
};


#endif
