#include <stdio.h>
#include <iostream.h>
#include "types.h"
#include "scheduler.h"
#include "phlayer.h"
#include "dllayer.h"
#include "nwlayer.h"

extern unsigned char cmdAddress;
extern unsigned char resAddress;

main(int argc, char *argv[] )
{
	if ( argc != 4 ) {
		printf("Please supply all the arguments\n");
		exit(1);
	}

	if ( atoi(argv[3]) == 0 ) {
		cmdAddress = addressA;
		resAddress = addressB;
	}
	else {
		cmdAddress = addressB;
		resAddress = addressA;
	}
		
	scheduler *sch = new scheduler;

	phlayer *ph = new phlayer(argv[1],argv[2]);
	dllayer *dl = new dllayer();
	nwlayer *nw = new nwlayer(STDIN_FILENO);

	ph->SetNPlus1Layer(dl);
	dl->SetNPlus1Layer(nw);
	dl->SetNMinus1Layer(ph);
	nw->SetNMinus1Layer(dl);

	ph->Init();
	dl->Init();

	sch->AddEventHandler(nw);
	sch->Run();
}
